Program Dir64;

uses
 tools;

Type
 tBAM=record
  Track :byte;
  Sector:byte;
  Format:byte;
  pad0  :byte;
  FAT   :array[1..35,1..4] of byte; { Sector Allocation }
  Name  :array[1..18] of char;
  ID    :array[1..2] of char;
  pad1  :byte;
  Chars :array[1..2] of char;
  pad2  :array[1..4] of byte;
  pad3  :array[1..85] of byte;
 end;

{ Directory entry structure }
 TDirEntry=record
  Kind   :byte;
  dTrack :byte;
  dSector:byte;
  Name   :array[1..16] of char;
  sTrack :byte;
  sSector:byte;
  Len    :byte;
  pad0   :array[1..4] of byte;
  oTrack :byte;
  oSector:byte;
  Blocks :word;
  pad1   :array[1..2] of byte;
 end;

{ Directory block structure }
 TDirectory=record
 { padding:array[1..2] of byte; }
  NextTrack :byte;
  NextSector:byte;
  Entry     :array[0..7] of TDirEntry;
 end;

const
 SectorCount:array[1..40] of integer=(
  21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,
  19,19,19,19,19,19,19,
  18,18,18,18,18,18,
  17,17,17,17,17,
  17,17,17,17,17	{ Tracks 36..40 }
 );

 SectorOfs:array[1..40] of integer=(
  0,21,42,63,84,105,126,147,168,189,210,231,252,273,294,315,336,
  357,376,395,414,433,452,471,
  490,508,526,544,562,580,
  598,615,632,649,666,
  683,700,717,734,751	{ Tracks 36..40 }
 );

 KindName:array[0..15] of string[3]=(
  'DEL','SEQ','PRG','USR','REL','EL?','EQ?','RG?','SR?','EL?','L??',
  'Q??','G??','R??','L??','???'
 );

 Flag:array[0..1] of char=('*',' ');

Function SectorOffset(Track,Sector:word):longint;
 begin
  if (Track<1)or(Track>40)
   or(Sector<0)or(Sector>=SectorCount[Track]) then
    SectorOffset:=-1
   else
    SectorOffset:=(SectorOfs[Track]+Sector) shl 8;
 end;


{ Read sector (256 bytes) }
function ReadSector(Handle,Track,Sector:word; Var Data):boolean;
 var
  offset:longint;
 begin
  offset:=SectorOffset(Track,Sector);
  ReadSector:=(Offset>=0)
           and(SeekFile(Handle,Offset))
           and(ReadFile(Handle,Data,256)=256);
 end;

var
 f:word;
 BAM:tBAM;
 DIR:TDirectory;
 i:byte;
 e:word;
 q:char;

begin
 f:=openfile('CBM64.D64'#0);
 if f=0 then exit;

 ReadSector(f,18,0,BAM);
 for i:=1 to sizeof(BAM.Name) do if BAM.Name[i]='' then BAM.Name[i]:=' ';

 WriteLn('0 "',BAM.Name,'" ',BAM.ID,' ',BAM.Chars);

 Dir.NextTrack:=BAM.Track;
 Dir.NextSector:=BAM.Sector;

 while (Dir.NextTrack<>0)
    and(ReadSector(f,Dir.NextTrack,Dir.NextSector,Dir)) do begin
    { Scan all 8 entries of a block }
    for e:=0 to 7 do with Dir.Entry[e] do begin
     q:='"';
     for i:=1 to sizeof(Name) do
      if Name[i]='' then begin
       Name[i]:=q;
       q:=' ';
      end;
     if kind<>0 then WriteLn(Blocks,'    "',Name,'  ',Flag[Kind shr 7],' ',KindName[Kind and 15]);
    end;
 end;

 e:=0; for i:=1 to 35 do e:=e+BAM.FAT[i,1];
 WriteLn(e,' BLOCKS FREE.');

 closefile(f);
end.