Unit HaltCode;

Interface

{$I CBMOPT.PAS}

{ Halt Error code }
Const
 hESC=10;
 hJAM=20;
 hSED=30;
 hIEC=40;
 hD016=50;

var ticks:longint absolute $40:$6C;
    time :longint;
    totalcycles:longint;


Implementation

Uses
 Memory,Tools;

Var
 OldExitProc:pointer;

Procedure ErrorHandler; far;
 begin
 { Restore ExitProc }
  ExitProc:=OldExitProc;
 {  Error message }
  asm mov ax,03h; int 10h end;
  WriteLn('CBM 64 Emulator by TOTH Paul (tothpaul@mygale.org)');
  Case ExitCode of
      0 : exit;
   hESC : Write('User exit');
   hJAM : Write('Code $'+Hexab(IR)+' crash the system');
   hSED : Write('Decimal mode not supported');
   hIEC : Write('IEC error func #',Peek(PC-1));
   hD016: Write('VIC Control Register D016 error');
  end;
  WriteLn(' at $'+Hexaw(PC-1));
  time:=ticks-time;
  writeln(totalcycles,' cycles ',(time/18.2):2:0,' seconds');
  writeln('Rate : ',(totalcycles/(time/18.2))/10000:2:2,'%');
 end;

{ Install Error Handler }
begin
 OldExitProc:=ExitProc;
 ExitProc:=@ErrorHandler;
end.