Unit IEC;

Interface

uses
 dialogs,haltcode,d64;

function OutputATN(Value:byte):byte;
function OutputSec(Value:byte):byte;
function Output(Value,EOI:byte):byte;
function Input(Var a:byte):byte;

Implementation

Const
{ C64 status codes }
 ST_OK           = $00;	{ No error }
 ST_READ_TIMEOUT = $02;	{ Timeout on reading }
 ST_TIMEOUT      = $03; { Timeout }
 ST_EOF          = $40; { End of file }
 ST_NOTPRESENT   = $80; { Device not present }

{ IEC command codes }
 ATN_LISTEN   = $20;
 ATN_UNLISTEN = $30;
 ATN_TALK     = $40;
 ATN_UNTALK   = $50;

{ IEC command codes }
 CMD_DATA =$60; { Data transfer }
 CMD_CLOSE=$E0; { Close Channel }
 CMD_OPEN =$F0; { Open Channel  }

Var
 ATN      :byte;
 Listener :word;
 Talker   :word;

 SecAddr   :byte;
 ReceiveCmd:byte;
 Name      :string;

Type
 TDevice=record
  FileName:string;
  Handle  :word;
 end;

Var
 Devices:array[0..15] of TDevice;

Function OpenDevice(Device:byte;Var AHandle:word):byte;
 begin
  with Devices[Device] do begin
   if Handle=0 then Handle:=LoadD64(FileName);
   AHandle:=Handle;
   if Handle=0 then OpenDevice:=ST_NOTPRESENT else OpenDevice:=ST_OK;
  end;
 end;

{ Output one byte with ATN (Talk/Listen/Untalk/Unlisten) }
function OutputATN(Value:byte):byte;
 begin
  ATN:=Value and $F0;
  Value:=Value and $F;
  OutputATN:=ST_OK;
  case ATN of
   ATN_LISTEN   : OutputATN:=OpenDevice(Value,Listener);
   ATN_UNLISTEN : Listener:=0;
   ATN_TALK     : OutputATN:=OpenDevice(Value,Talker);
   ATN_UNTALK   : Talker:=0;
   else           OutputATN:=ST_TIMEOUT;
  end;
 end;

Function CloseChannel(Channel:byte):byte;
 begin
  CloseChannel:=ST_OK;
 end;


{ Output secondary address }
function OutputSec(Value:byte):byte;
 begin
  OutputSec:=ST_OK;
  SecAddr:=Value and $F;
  ReceiveCmd:=Value and $F0;
  if ATN=ATN_LISTEN then begin
   case ReceiveCmd of
    CMD_OPEN : Name:='';
    CMD_CLOSE: CloseChannel(SecAddr);
   end;
  end;
 end;

{  Output one byte }
function Output(Value,EOI:byte):byte;
 begin
  OutPut:=ST_TIMEOUT;
  if ATN=ATN_LISTEN then begin
   case ReceiveCmd of
    CMD_OPEN : begin
     Name:=Name+Chr(Value);
     if EOI>0 then Output:=D64.Load(Listener,SecAddr,Name);
    end;
    CMD_DATA : begin
    { return listener->Write(sec_addr, byte, eoi); }
     halt(hIEC);
    end;
   end;
  end;
 end;

function Input(Var a:byte):byte;
 begin
  if (Talker>0)and(ReceiveCmd=CMD_DATA) then begin
   Input:=D64.Read(Talker,SecAddr,a);
  end else begin
   a:=0;
   Input:=ST_TIMEOUT;
  end;
 end;

begin
 FillChar(Devices,SizeOf(Devices),0);
end.